package n14;
import java.io.*;

import javax.servlet.http.*;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.xerces.dom.DocumentImpl;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Base {
	//connection variables
	private ResultSet rs;
	private Statement stmt;
	private Connection con;
	private String dbName,userName,userPass;
	//Variables for xml response
	private Element e,e1;
	private Node n;
	
	private Document xmldoc = new DocumentImpl();
	public void con(String dbName,String userName,String userPass){
		this.dbName = dbName;
		this.userName = userName;
		this.userPass = userPass;
	}
	//Connect to database (Mysql)
	private void startConnect() throws ClassNotFoundException, SQLException{
		Class.forName("org.gjt.mm.mysql.Driver");
		String url = "jdbc:mysql://localhost:3306/"+dbName;
		con = DriverManager.getConnection(url, userName, userPass);		
		con.setAutoCommit(false);
		stmt = con.createStatement();
	}
	//Close connection
	public void closeConnect() throws SQLException{
		con.close();
	}
	//Add author to database

	// Get base XML for grid
	public void createXML(String posStart, String count,String nm_mask, String cd_mask, String orderBy, String direction, HttpServletResponse response) throws IOException, ClassNotFoundException, SQLException{
	    response.setContentType("text/xml");
	    PrintWriter out = response.getWriter();
		Element root = xmldoc.createElement("rows");
		startConnect();

		String sql="SELECT  * FROM Grid WHERE 0=0";
		if (nm_mask!=null) sql+=" and item_nm like '"+nm_mask+"%' ";
		if (cd_mask!=null) sql+=" and item_cd like '"+cd_mask+"%' ";
		
		if (posStart==null) posStart="0";
		if (count==null) count="20";
		if(posStart.equals("0"))
		{
			rs = stmt.executeQuery("SELECT COUNT(*) as cnt FROM ( " +sql+" ) as tbl");
			rs.next();
			root.setAttributeNS(null,"total_count",rs.getString("cnt"));
		}
		root.setAttributeNS(null,"pos",posStart);

		if (direction==null) direction="ASC";
		if ((orderBy!=null)&&(orderBy.equals("1")))
			orderBy="item_cd";
		else
			orderBy="item_nm";

		sql+= " Order By "+orderBy+" "+direction;
		sql+= " LIMIT "+posStart+","+count;

		rs = stmt.executeQuery(sql);
		while (rs.next())
		{
			e = xmldoc.createElementNS(null,"row");
			e.setAttributeNS(null,"id",rs.getString("item_id"));

			e1 = xmldoc.createElementNS(null,"cell");
			e1.appendChild(xmldoc.createTextNode(rs.getString("item_nm")));
			e.appendChild(e1);
			e1 = xmldoc.createElementNS(null,"cell");
			e1.appendChild(xmldoc.createTextNode(posStart));
			e.appendChild(e1);
			e1 = xmldoc.createElementNS(null,"cell");
			e1.appendChild(xmldoc.createTextNode(rs.getString("item_cd")));
			e.appendChild(e1);
			root.appendChild(e);				
		}
		
		
		closeConnect();
		xmldoc.appendChild(root);
	    OutputFormat format = new OutputFormat(xmldoc);
	    format.setIndenting(true); 

	    XMLSerializer serializer = new XMLSerializer(out,format);
        try {
			serializer.asDOMSerializer();
			serializer.serialize(xmldoc);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			
		return;
	}
	
	public static void main(String args[]) {
		
	}
}
